



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深度解析PHP数组函数array_merge</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深度解析PHP数组函数array_merge</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 04:20:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　</p>
<p>　　很久之前就用到过这个函数，只不不过是简单的用用而已并没有做太深入的研究</p>
<p>　　今天在翻阅别人博客时看到了对array_merge的一些使用心得，故此自己来进行一次总结。</p>
<p>　　array_merge是将一个或者多个数组进行合并。</p>
<p>　　这个函数多用于在从数据库中取出的结果集的合并操作。</p>
<p>　　参数配置也很简单array_merge(arr1,arr2,arrN)</p>
<p>　　<strong>注意此处的参数必须为数组，否则会报错。</strong></p>
<p>　　虽然，看起来很简单，但是其中也有不少的坑。</p>
<p>　　我们将从单数组和多数组的方向来进行分析。</p>
<p>　　1.多个数组进行合并操作（自定义键名）：</p>
<p>　　从下面的运行结果可以看出$arr1与$arr2中键名相同的数据已被覆盖。</p>
<p>　　后面的数组会将前面数组中键相同的值覆盖。</p>
<div>
<pre class="prettyprint linenums">&lt;?php

$arr1 = array('a'=&gt;'1','b'=&gt;'2');<br />
$arr2 = array('a'=&gt;'1','b'=&gt;'3','c'=&gt;'2');

$ret = array_merge($arr1,$arr2);<br />
print_r($ret);

//run result<br />
Array<br />
(<br />
    [a] =&gt; 1<br />
    [b] =&gt; 3<br />
    [c] =&gt; 2<br />
)</pre>
</div>
<p>　　2.多个数组进行合并操作（自定义数字键名）：</p>
<p>　　如果数组中的键名为数字时，会格式化键名并保留所有键值。</p>
<div>
<pre class="prettyprint linenums">&lt;?php

$arr1 = array(1=&gt;'1',2=&gt;'2');<br />
$arr2 = array(1=&gt;'1',2=&gt;'3',6=&gt;'2');

$ret = array_merge($arr1,$arr2);<br />
print_r($ret);

//run result

Array<br />
(<br />
    [0] =&gt; 1<br />
    [1] =&gt; 2<br />
    [2] =&gt; 1<br />
    [3] =&gt; 3<br />
    [4] =&gt; 2<br />
)</pre>
</div>
<p>　　3.多个数组进行合并操作（无输入键名）：</p>
<div>
<pre class="prettyprint linenums">&lt;?php

$arr1 = array(1,2);<br />
$arr2 = array(1,2,6);

$ret = array_merge($arr1,$arr2);<br />
print_r($ret);

//run result<br />
Array<br />
(<br />
    [0] =&gt; 1<br />
    [1] =&gt; 2<br />
    [2] =&gt; 1<br />
    [3] =&gt; 2<br />
    [4] =&gt; 6<br />
)</pre>
</div>
<p>　　4.多数在合并操作（当一个数组为空时）：</p>
<p>　　一个数组为空的这种操作很常见，无论哪个数组为空都会显示现有的值。</p>
<p>　　但有一个前提是如果第一个参数是空数组的话函数会将值设为NULL，</p>
<p>　　所以，需要在数组前添加(array)来强调即使是空值也是一个数组，</p>
<p>　　来避免一些不必要的问题的出现。</p>
<div>
<pre class="prettyprint linenums">&lt;?php

$arr1 = array();<br />
$arr2 = array(1,2,6);

$ret = array_merge((array)$arr1,(array)$arr2);<br />
print_r($ret);

//run result<br />
Array<br />
(<br />
    [0] =&gt; 1<br />
    [1] =&gt; 2<br />
    [2] =&gt; 6<br />
)</pre>
</div>
<p>　　5.单数组操作：</p>
<p>　　单数组这种情况一般不会用到array_merge()，因为这个函数是用来合并数组的。</p>
<p>　　但是如果想恢复到原始的相关键名可以使用这个函数，但并不建议这么做。</p>
<p>　　因为有比它更好的函数可以使用array_values()</p>
<p>　　单数组操作其实和上面的2、3两种情况很类似，当键名为数字时则会格式化键名，否则直接显示。</p>
<div>
<pre class="prettyprint linenums">&lt;?php

$arr1 = array(1=&gt;1,3=&gt;2,6=&gt;6);

$ret = array_merge($arr1);<br />
print_r($ret);

//run result<br />
Array<br />
(<br />
    [0] =&gt; 1<br />
    [1] =&gt; 2<br />
    [2] =&gt; 6<br />
)</pre>
</div>
<p>　　6.当遇到两个数组合并的时候可以使用array_merge()，后面的数组会与前面的数组进行合并</p>
<p>　　但是想用前面的数组与后面的数组进行合并时怎么办？</p>
<p>　　难道把array_merge()中的两个数组换一下位置吗？其实有一个更简单的方法。</p>
<p>　　就是使用&ldquo;+&rdquo;来完成操作。</p>
<div>
<pre class="prettyprint linenums">&lt;?php<br />
$arr1 = array('a'=&gt;1,'b'=&gt;2);<br />
$arr2 = array('a'=&gt;1,'b'=&gt;3,'c'=&gt;6);

$ret = $arr1+$arr2;<br />
print_r($ret);

//run result<br />
Array<br />
(<br />
    [a] =&gt; 1<br />
    [b] =&gt; 2<br />
    [c] =&gt; 6<br />
)</pre>
</div>
<p>本文为茴香饺子博客的原创，欢迎转载，转载请注明出处　　</p>
<p>茴香饺子博客http://www.cnblogs.com/hxjz/</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv2kgy9.html">《C&num;高级编程》学习总结之LINQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j2ene8.html">&amp;lt&semi;转&amp;gt&semi;人生与最速曲线</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10yg79.html">SqlSever基础 intersect 交集 两个查询结果共有的</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wxx5wq.html">理解Session的几种模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qderk1z9.html">javascript中this的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xvxx08.html">ionic 手机端如何嵌入视频iframe</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde4wox9.html">物联网传输协议MQTT</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zjo509.html">JS树型菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzl7r8.html">网络相关系列之三：通过GET和POST方法发送数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0dpk9.html">java的断言&lpar;assert&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oxl3j8.html">在 Laravel 项目中使用 Elasticsearch 做引擎，scout 全文搜索&lpar;小白出品&comma; 绝对白话&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjnx3q.html">iis发布后模板字体不能加载的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllpxeq.html">GDB dump mem example和命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvxex8.html">ZooKeeper系列&lpar;6&rpar;：ZooKeeper的伸缩性和Observer角色</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv20xj8.html">阻塞式I&sol;O实现简单TCP通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rpdy39.html">潭州课堂25班：Ph201805201 django 项目 第十五课 用户注册功能后台实现 &lpar;课堂笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj4drr9.html">&OpenCurlyDoubleQuote;数学口袋精灵&rdquo;App的第三个Sprint计划----开发日记&lpar;第十一天12&period;17&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvp3pr8.html">Python爬取金山词霸每日一句，存储到MySQL中</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pworod8.html">FBX SDK在vs 2010下面的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25pdmoq.html">Hanlp分词实例：Java实现TFIDF算法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mezym8.html">C&num; 遍历泛型集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zojdn3q.html">stick footer布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjrkvz8.html">【Tomcat源码学习】-5&period;请求处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd3nkd9.html">java中创建对象中使用默认构造函数的注意点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd3j7k9.html">wpf之StackPanel、WrapPanel、WrapPanel之间的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j2wlo8.html">yum仓库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1klkr09.html">css 画出三角形</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mpm5m8.html">Java设计模式&mdash;&mdash;&mdash;静态工厂</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojgje5q.html">10个漂亮的jQuery日历插件下载【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg154e8.html">【代码学习】PHP文件的上传和下载</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
